package com.foo;

import javax.ejb.EJB;
import javax.naming.NamingException;

import org.jboss.arquillian.api.Deployment;
import org.jboss.arquillian.api.OperateOnDeployment;
import org.jboss.arquillian.junit.Arquillian;
import org.jboss.shrinkwrap.api.Archive;
import org.jboss.shrinkwrap.api.ArchivePaths;
import org.jboss.shrinkwrap.api.ShrinkWrap;
import org.jboss.shrinkwrap.api.spec.EnterpriseArchive;
import org.jboss.shrinkwrap.api.spec.JavaArchive;
import org.junit.Test;
import org.junit.runner.RunWith;

@RunWith(Arquillian.class)
public class FooBarTest {

    @Deployment(order = 1, name = "1", testable = false)
    public static Archive<?> createDeploymentFoo() {
        return ShrinkWrap.create(EnterpriseArchive.class, "foo.ear").addAsModule(
                ShrinkWrap.create(JavaArchive.class, "foo.jar").addClasses(FooRemote.class, Foo.class))
                .addAsManifestResource("ejb-jar.xml", ArchivePaths.create("ejb-jar.xml"));

    }

    @Deployment(order = 2, name = "2")
    public static Archive<?> createDeploymentBar() {
        return ShrinkWrap.create(EnterpriseArchive.class, "bar.ear")
                .addAsModule(ShrinkWrap.create(JavaArchive.class, "bar.jar").addClasses(BarRemote.class, Bar.class))
                .addAsManifestResource("ejb-jar.xml", ArchivePaths.create("ejb-jar.xml"))
                .addAsLibrary(ShrinkWrap.create(JavaArchive.class, "foo.jar").addClasses(FooRemote.class));
    }

    @EJB(mappedName = "ejb/Bar")
    private BarRemote bar;

    @Test
    @OperateOnDeployment(value="2")
    public void testbar() throws NamingException {
        System.out.println(bar.sayHello());
    }

}
